package cokr.xit.fims.sndb.dao;

import java.util.List;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.sndb.SndbQuery;
import cokr.xit.fims.sndb.Sndng;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 발송 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-25	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("sndngMapper")
public interface SndngMapper extends AbstractMapper {
	/**지정한 조건에 따라 발송 대장 목록을 조회하여 반환한다.<br />
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> selectSndngList(SndbQuery req);

	/**지정한 조건에 따라 발송 대장 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<Sndng> selectSndngs(SndbQuery req);

	default DataObject selectSndngInfo(SndbQuery req) {
		// 삭제여부
		if (req.getDelYn() == null)
			req.setDelYn("N");
		// 기본 정렬
		if (req.getOrderBy() == null)
			req.setOrderBy("S.SNDNG_ID DESC");

		List<DataObject> sndngs = selectSndngList(req);
		return !sndngs.isEmpty() ? sndngs.get(0) : null;
	}

	/**지정한 조건에 따라 계고장 발송 대상 목록을 조회하여 반환한다.<br />
	 * @param req 발송 대장 조회 조건
	 * @return 계고장 발송 대상 목록
	 */
	List<DataObject> selectWrngTrgtList(SndbQuery req);

	/**지정한 조건에 따라 계고장 발송 대상 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 계고장 발송 대상 객체 목록
	 */
	List<DataObject> selectWrngTrgts(SndbQuery req);

	default DataObject selectWrngTrgtInfo(String crdnId) {
		List<DataObject> wrngTrgtInfo = selectWrngTrgts(
			new SndbQuery()
				.setCrdnId(crdnId)
				.setDelYn("N")
		);
		return !wrngTrgtInfo.isEmpty() ? wrngTrgtInfo.get(0) : null;
	}

	/**지정한 조건에 따라 계고장 발송 대상의 단속ID 들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 계고장 발송 대상 단속ID 목록
	 */
	List<DataObject> selectWrngTrgtCrdnIds(SndbQuery req);

	/**지정한 조건에 따라 사전통지 발송 대상 목록을 조회하여 반환한다.<br />
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> selectAdvntceTrgtList(SndbQuery req);

	/**지정한 조건에 따라 사전통지 발송 대상 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<DataObject> selectAdvntceTrgts(SndbQuery req);

	default DataObject selectAdvntceTrgtInfo(String crdnId) {
		List<DataObject> advntceTrgtInfo = selectAdvntceTrgts(
			new SndbQuery()
				.setCrdnId(crdnId)
				.setDelYn("N")
		);
		return !advntceTrgtInfo.isEmpty() ? advntceTrgtInfo.get(0) : null;
	}

	/**지정한 조건에 따라 사전통지 발송 대상의 단속ID 들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 사전통지 발송 대상 단속ID 목록
	 */
	List<DataObject> selectAdvntceTrgtCrdnIds(SndbQuery req);

	/**지정한 조건에 따라 단속, 납부자, 부과 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 계고장 발송 대상 객체 목록
	 */
	List<DataObject> selectCrdnPayerTrgts(SndbQuery req);

	default DataObject selectCrdnPayerInfo(String crdnId) {
		List<DataObject> crdnPayerInfo = selectCrdnPayerTrgts(new SndbQuery().setCrdnId(crdnId));

		return !crdnPayerInfo.isEmpty() ? crdnPayerInfo.get(0) : null;
	}

	/**지정한 조건에 따라 고지서 발송 대상 목록을 조회하여 반환한다.<br />
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> selectNhtTrgtList(SndbQuery req);

	/**지정한 조건에 따라 사전통지 발송 대상 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<DataObject> selectNhtTrgts(SndbQuery req);

	default DataObject selectNhtTrgtInfo(String crdnId) {
		List<DataObject> nhtTrgtInfo = selectNhtTrgts(
			new SndbQuery()
				.setCrdnId(crdnId)
				.setDelYn("N")
		);
		return !nhtTrgtInfo.isEmpty() ? nhtTrgtInfo.get(0) : null;
	}

	/**지정한 조건에 따라 고지서 발송 대상의 단속ID 들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 사전통지 발송 대상 단속ID 목록
	 */
	List<DataObject> selectNhtTrgtCrdnIds(SndbQuery req);

	/**발송 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"sndng" - 발송 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertSndng(Sndng sndng);

	/**발송 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"sndng" - 발송 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateSndng(Sndng sndng);

	/**지정한 발송 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"sndng" - 발송 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteSndng(Sndng sndng);

	/**발송 대장 정보의 발송 상태 코드를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"sndng" - 발송 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateSndngSttsCd(Sndng sndng);

	/**전자우편 발송 내역을 수정한다.
	 * @param params 파라미터
	 * <ul><li>"sndngDtl" - 발송 상세</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateEPostSndng(Sndng sndng);
}